
//Includes:
#include <sourcemod>
#include <sdktools>
#include <colors>

//Terminate:
#pragma semicolon		1
#pragma compress		0

//Definitions:
#define PLUGINVERSION		"1.00.01"
#define SAYTIMER 		"7.5"

//Say Buffer:
static Float:CanSay[MAXPLAYERS + 1] = {0.0,...};

//Plugin Info:
public Plugin:myinfo =
{
	name = "Say Sounds, Unit Edition",
	author = "Master(D)",
	description = "enable players to say hl2 sounds",
	version = PLUGINVERSION,
	url = ""
};

//Initation:
public OnPluginStart()
{

	//Command Listener:
	AddCommandListener(CommandSay, "say");

	//Sounds:
	RegConsoleCmd("sm_sounds", Commandsounds);

}

//RollTheDice:
public Action:Commandsounds(Client, Args)
{

	//Is Console:
	if(Client == 0)
	{

		//Print:
		PrintToServer("|RP| this command can only be used ingame.");

		//Return:
		return Plugin_Handled;
	}

	SendHelpMenu(Client, 1, 60, 20, 255, 20, 250, "Hello and welcome to\nthe say sounds list!\n\n    01: get the hell out\n    02: hack\n    03: headcrab\n    04: like that\n    05: nice\n    06: oh no\n    07: the hacks\n    08: zombie\n    09: haha\n    10: laugh\n    11: quickly\n    12: knock knock\n    13: allright\n    14: too loud\n    15: me\n    16: wait a minute\n    17: sure\n    18: have fun");

	//Return:
	return Plugin_Handled;
}

stock SendHelpMenu(client, level, time, r, g, b, a, String:text[], any:...)
{

	//Declare:
	new String:message[1024];

	//Format:
	VFormat(message, sizeof(message), text, 9);

	//Handle:
	new Handle:kv = CreateKeyValues("message", "title", message);

	//Set Colour:
	KvSetColor(kv, "color", r, g, b, a);

	//Set Value:
	KvSetNum(kv, "level", level);
	KvSetNum(kv, "time", time);

	//Send:
	CreateDialog(client, kv, DialogType_Text);

	//Close:
	CloseHandle(kv);
}

//Handle Chat:
public Action:CommandSay(Client, const String:Command[], Argc)
{

	//Is Valid:
	if(Client <= 0 || !IsClientConnected(Client) || !IsClientInGame(Client)) return Plugin_Handled; 

	//Declare:
	decl String:Text[256];

	//Get Args
	GetCmdArgString(Text, sizeof(Text));

	//Strip All Quoats:
	StripQuotes(Text);

	//Trip String:
	TrimString(Text);

	//Is Admin Command:
	if(Text[0] == '/')
	{

		//Return:
		return Plugin_Handled;
	}

	//Is Valid:
	if(CanSay[Client] == 0)
	{

		//Check:
		CheckStringSound(Client, Text);
	}

	//Return:
	return Plugin_Continue;
}
stock bool:CheckStringSound(Client, String:Text[])
{

	//Declare:
	decl String:Sound[256], String:Model[256]; new bool:CanPlay = false;

	//Get Prop String:
	GetEntPropString(Client, Prop_Data, "m_ModelName", Model, sizeof(Model));  

	//Get Name:
	if(StrContains(Text, "get the hell out", false) != -1)
	{

		//Is Female:
		if(StrContains(Model, "female", false) != -1)
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/npc/female01/gethellout.wav");
		}

		//Override:
		else
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/npc/male01/gethellout.wav");
		}

		//Initulize:
		CanPlay = true;
	}

	//Get Name:
	if(StrContains(Text, "hack", false) != -1)
	{

		//Is Female:
		if(StrContains(Model, "female", false) != -1)
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/npc/female01/hacks01.wav");
		}

		//Override:
		else
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/npc/male01/hacks01.wav");
		}

		//Initulize:
		CanPlay = true;
	}

	//Get Name:
	if(StrContains(Text, "headcrab", false) != -1 || StrContains(Text, "head crab", false) != -1)
	{

		//Is Female:
		if(StrContains(Model, "female", false) != -1)
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/npc/female01/headcrabs01.wav");
		}

		//Override:
		else
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/npc/male01/headcrabs01.wav");
		}

		//Initulize:
		CanPlay = true;
	}

	//Get Name:
	if(StrContains(Text, "like that", false) != -1)
	{

		//Is Female:
		if(StrContains(Model, "female", false) != -1)
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/npc/female01/likethat.wav");
		}

		//Override:
		else
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/npc/male01/likethat.wav");
		}

		//Initulize:
		CanPlay = true;
	}

	//Get Name:
	if(StrContains(Text, "nice", false) != -1)
	{

		//Is Female:
		if(StrContains(Model, "female", false) != -1)
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/npc/female01/nice01.wav");
		}

		//Override:
		else
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/npc/male01/nice.wav");
		}

		//Initulize:
		CanPlay = true;
	}

	//Get Name:
	if(StrContains(Text, "oh no", false) != -1)
	{

		//Is Female:
		if(StrContains(Model, "female", false) != -1)
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/npc/female01/ohno.wav");
		}

		//Override:
		else
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/npc/male01/ohno.wav");
		}

		//Initulize:
		CanPlay = true;
	}

	//Get Name:
	if(StrContains(Text, "the hacks", false) != -1)
	{

		//Is Female:
		if(StrContains(Model, "female", false) != -1)
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/npc/female01/thehacks01.wav");
		}

		//Override:
		else
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/npc/male01/thehacks01.wav");
		}

		//Initulize:
		CanPlay = true;
	}

	//Get Name:
	if(StrContains(Text, "zombie", false) != -1)
	{

		//Is Female:
		if(StrContains(Model, "female", false) != -1)
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/npc/female01/zombies01.wav");
		}

		//Override:
		else
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/npc/male01/zombies01.wav");
		}

		//Initulize:
		CanPlay = true;
	}

	//Get Name:
	if(StrContains(Text, "hehe", false) != -1)
	{

		//Is Female:
		if(StrContains(Model, "female", false) != -1)
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/eli_lab/al_laugh01.wav");

			//Initulize:
			CanPlay = true;
		}

		//Override:
		else
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/ravenholm/madlaugh04.wav");

			//Initulize:
			CanPlay = true;
		}
	}
	//Get Name:
	if(StrContains(Text, "haha", false) != -1)
	{

		//Is Female:
		if(StrContains(Model, "female", false) != -1)
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/eli_lab/al_laugh02.wav");

			//Initulize:
			CanPlay = true;
		}

		//Override:
		else
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/npc/barney/ba_laugh02.wav");

			//Initulize:
			CanPlay = true;
		}
	}

	//Get Name:
	if(StrContains(Text, "laugh", false) != -1)
	{

		//Format:
		Format(Sound, sizeof(Sound), "vo/ravenholm/madlaugh03.wav");

		//Initulize:
		CanPlay = true;
	}

	//Get Name:
	if(StrContains(Text, "quickly", false) != -1)
	{

		//Format:
		Format(Sound, sizeof(Sound), "vo/ravenholm/monk_quicklybro.wav");

		//Initulize:
		CanPlay = true;
	}

	//Get Name:
	if(StrContains(Text, "knock knock", false) != -1)
	{

		//Format:
		Format(Sound, sizeof(Sound), "vo/trainyard/cit_drunk.wav");

		//Initulize:
		CanPlay = true;
	}

	//Get Name:
	if(StrContains(Text, "allright", false) != -1)
	{

		//Format:
		Format(Sound, sizeof(Sound), "vo/trainyard/cit_lug_allright.wav");

		//Initulize:
		CanPlay = true;
	}

	//Get Name:
	if(StrContains(Text, "too loud", false) != -1)
	{

		//Format:
		Format(Sound, sizeof(Sound), "vo/trainyard/cit_tooloud.wav");

		//Initulize:
		CanPlay = true;
	}

	//Get Name:
	if(StrContains(Text, "me", false) != -1)
	{

		//Format:
		Format(Sound, sizeof(Sound), "vo/trainyard/man_me.wav");

		//Initulize:
		CanPlay = true;
	}

	//Get Name:
	if(StrContains(Text, "wait a minute", false) != -1)
	{

		//Format:
		Format(Sound, sizeof(Sound), "vo/trainyard/man_waitaminute.wav");

		//Initulize:
		CanPlay = true;
	}

	//Get Name:
	if(StrContains(Text, "sure", false) != -1)
	{

		//Format:
		Format(Sound, sizeof(Sound), "vo/eli_lab/al_gravgun.wav");

		//Initulize:
		CanPlay = true;
	}

	//Get Name:
	if(StrContains(Text, "hum", false) != -1)
	{

		//Format:
		Format(Sound, sizeof(Sound), "vo/eli_lab/al_hums.wav");

		//Initulize:
		CanPlay = true;
	}

	//Get Name:
	if(StrContains(Text, "have fun", false) != -1)
	{

		//Format:
		Format(Sound, sizeof(Sound), "vo/eli_lab/al_havefun.wav");

		//Initulize:
		CanPlay = true;
	}


	//Get Name:
	if(StrContains(Text, "gman", false) != -1)
	{

		//Is Valid;
		if(StrEqual(Model, "models/gman.mdl"))
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/gman_misc/gman_03.wav");

			//Initulize:
			CanPlay = true;
		}
	}

	//Get Name:
	if(StrContains(Text, "oh shit", false) != -1)
	{

		//Is Valid;
		if(StrEqual(Model, "models/breen.mdl"))
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/citadel/br_ohshit.wav");

			//Initulize:
			CanPlay = true;
		}
	}

	//Get Name:
	if(StrContains(Text, "well done", false) != -1)
	{

		//Is Valid;
		if(StrEqual(Model, "models/monk.mdl"))
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/ravenholm/firetrap_welldone.wav");

			//Initulize:
			CanPlay = true;
		}
	}

	//Get Name:
	if(StrContains(Text, "trubling", false) != -1)
	{

		//Is Valid;
		if(StrEqual(Model, "models/Kleiner.mdl"))
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/k_lab2/kl_atthecitadel01.wav");

			//Initulize:
			CanPlay = true;
		}
	}

	//Get Name:
	if(StrContains(Text, "gman", false) != -1)
	{

		//Is Valid;
		if(StrEqual(Model, "models/gman.mdl"))
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/gman_misc/gman_03.wav");

			//Initulize:
			CanPlay = true;
		}
	}

	//Get Name:
	if(StrContains(Text, "dog come", false) != -1)
	{

		//Is Valid;
		if(StrEqual(Model, "models/alyx.mdl"))
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/eli_lab/al_dogcome.wav");

			//Initulize:
			CanPlay = true;
		}
	}

	//Get Name:
	if(StrContains(Text, "earned it", false) != -1)
	{

		//Is Valid;
		if(StrEqual(Model, "models/alyx.mdl"))
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/eli_lab/al_earnedit.wav");

			//Initulize:
			CanPlay = true;
		}
	}

	//Get Name:
	if(StrContains(Text, "give it a try", false) != -1)
	{

		//Is Valid;
		if(StrEqual(Model, "models/alyx.mdl"))
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/eli_lab/al_giveittry.wav");

			//Initulize:
			CanPlay = true;
		}
	}

	//Get Name:
	if(StrContains(Text, "dog come", false) != -1)
	{

		//Is Valid;
		if(StrEqual(Model, "models/alyx.mdl"))
		{

			//Format:
			Format(Sound, sizeof(Sound), "vo/eli_lab/al_dogcome.wav");

			//Initulize:
			CanPlay = true;
		}
	}

	//Is Valid:
	if(CanPlay)
	{

		//Spam:
		if(CanSay[Client] > (GetGameTime() - StringToFloat(SAYTIMER)))
		{

			//Declare:
			new Float:ClientOrigin[3];

			//Initialize:
			GetClientAbsOrigin(Client, ClientOrigin);

			//Is Precached:
			if(IsSoundPrecached(Sound)) PrecacheSound(Sound);

			//Play Sound:
			EmitAmbientSound(Sound, ClientOrigin, Client, SNDLEVEL_NORMAL);

			//Initulize:
			CanSay[Client] = GetGameTime();

			//Print:
			CPrintToChat(Client, "\x070xADD8|RP|\x01 you have said a Say Sound!");

			//Return:
			return true;
		}
	}

	//Return:
	return false;
}