
//Includes:
#include <sourcemod>
#include <sdktools>
#include <StockRP>
#include <colors>

//Terminate:
#pragma semicolon		1
#pragma compress		0

//Definitions:
#define PLUGINVERSION		"1.52.81"

//global variables
static String:AdsPath[256];
static String:ServerMap[64];

//Plugin Info:
public Plugin:myinfo =
{
	name = "Official Roleplay Advertisement",
	author = "Master(D)",
	description = "Exension for the Roleplay Main Plugin Advertisement (Lite)",
	version = PLUGINVERSION,
	url = ""
};

//Initation:
public OnPluginStart()
{

	//Print Server If Plugin Start:
	PrintToConsole(0, "|RolePlay| Advertisement Successfully Loaded (v%s)!", PLUGINVERSION);

	//Server Version:
	CreateConVar("sm_roleplay_advertisment_version", PLUGINVERSION, "show the version of the roleplaying mod", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_UNLOGGED|FCVAR_DONTRECORD|FCVAR_REPLICATED|FCVAR_NOTIFY);

	//Declare:
	decl String:Path[256];

	//Build:
	BuildPath(Path_SM, Path, 256, "data/roleplay/%s/", ServerMap);

	//Create Folder:
	CreateDirectory(Path, 511);

	//NPC DB:
	BuildPath(Path_SM, AdsPath, 256, "data/roleplay/%s/ads.txt", ServerMap);
	if(FileExists(AdsPath) == false) SetFailState("[SM] ERROR: Missing file '%s'", AdsPath);

	//Handle:
	CreateTimer(45.0, ShowAdsChatText, _, TIMER_REPEAT);

	//Handle:
	CreateTimer(60.0, ShowAdsHintText, _, TIMER_REPEAT);

	//Handle:
	CreateTimer(75.0, ShowAdsCentreText, _, TIMER_REPEAT);
}

//Client Hud:
public Action:ShowAdsChatText(Handle:Timer)
{

	//Declare:
	decl Handle:Vault;
	decl String:Text[255], String:NewText[1024], String:Number[255];

	//Initialize:
	Vault = CreateKeyValues("Vault");

	//Retrieve:
	FileToKeyValues(Vault, AdsPath);

	//Random:
	new Roll = GetRandomInt(1, 25);

	//Convert:
	IntToString(Roll, Number, 255);

	//Load:
	LoadString(Vault, "ChatText", Number, "Null", Text);

	//Is Valid Plugin Name:
	if(StrContains(Text, "Null", false) == 0)
	{

		//Handle:
		CreateTimer(0.1, ShowAdsChatText, _);

		//Return:
		return;
	}

	//Format:
	Format(NewText, sizeof(NewText), "{powderblue}|INFO|{lightgreen} %s", Text);

	//Print:
	CPrintToChatAll("%s", NewText);

	//Find:
	KeyValuesToFile(Vault, AdsPath);

	//Close:
	CloseHandle(Vault);
}

//Client Hud:
public Action:ShowAdsHintText(Handle:Timer)
{

	//Declare:
	decl Handle:Vault;
	decl String:Text[255], String:Number[255];

	//Initialize:
	Vault = CreateKeyValues("Vault");

	//Retrieve:
	FileToKeyValues(Vault, AdsPath);

	//Random:
	new Roll = GetRandomInt(1, 10);

	//Convert:
	IntToString(Roll, Number, 255);

	//Load:
	LoadString(Vault, "DiagolText", Number, "Null", Text);

	//Is Valid Plugin Name:
	if(StrContains(Text, "Null", false) == 0)
	{

		//Handle:
		CreateTimer(0.1, ShowAdsHintText, _);

		//Return:
		return;
	}

	//Print:
	CPrintDialogTextAll(1, 7.0, 50, 250, 50, 250, Text);

	//Find:
	KeyValuesToFile(Vault, AdsPath);

	//Close:
	CloseHandle(Vault);
}

//Client Hud:
public Action:ShowAdsCentreText(Handle:Timer)
{

	//Declare:
	decl Handle:Vault;
	decl String:Text[255], String:Number[255];

	//Initialize:
	Vault = CreateKeyValues("Vault");

	//Retrieve:
	FileToKeyValues(Vault, AdsPath);

	//Random:
	new Roll = GetRandomInt(1, 10);

	//Convert:
	IntToString(Roll, Number, 255);

	//Load:
	LoadString(Vault, "CenterText", Number, "", Text);



	//Is Valid Plugin Name:
	if(StrContains(Text, "Null", false) == 0)
	{

		//Handle:
		CreateTimer(0.1, ShowAdsCentreText, _);

		//Return:
		return;
	}


	//Print:
	PrintCenterTextAll(Text);

	//Find:
	KeyValuesToFile(Vault, AdsPath);

	//Close:
	CloseHandle(Vault);
}


LoadString(Handle:Vault, const String:Key[32], const String:SaveKey[255], const String:DefaultValue[255], String:Reference[255])
{

	//Skip:
	KvJumpToKey(Vault, Key, false);

	//Get KV:
	KvGetString(Vault, SaveKey, Reference, 255, DefaultValue);

	//Restart KV:
	KvRewind(Vault);
}
