
//Includes:
#include <sourcemod>
#include <sdktools>
#include <StockRP>

//Terminate:
#pragma semicolon		1
#pragma compress		0

#define PLUGINVERSION "1.00.01"

public Plugin:myinfo =
{
	name = "Official UNIT-Edition antivirus and cheat",
	author = "devicenull, Master(D)",
	description = "Locks RCON password and patches various exploitable commands",
	version = PLUGINVERSION,
	url = "http://www.sourcemod.net/"
};

/* Entities that are not allowed to be created with ent_create or give */
new String:forbidden_ents[][] = { "point_servercommand", "point_clientcommand", "logic_timer", "logic_relay"
	,"logic_auto", "logic_autosave", "logic_branch", "logic_case", "logic_collision_pair", "logic_compareto" 
	,"logic_lineto", "logic_measure_movement", "logic_multicompare", "logic_navigation" };

/*Strings that are not allowed to be present in ent_fire commands */
new String:forbidden_cmds[][] = { "quit", "quti", "restart", "sm", "admin", "ma_", "rcon", "sv_", "mp_", "meta", "alias" };

/* Commands that will have the FCVAR_CHEATS flag added, to prevent execution */
new String:cheat_flag[][] = { "ai_test_los", "dbghist_dump", "dump_entity_sizes", "dump_globals", "dump_terrain", "dumpcountedstrings"
				, "dumpentityfactories", "dumpeventqueue", "es_version", "groundlist", "listmodels", "mem_dump", "mp_dump_timers"
				, "npc_ammo_deplete", "npc_heal", "npc_speakall", "npc_thinknow", "physics_budget", "physics_debug_entity", "physics_report_active"
				, "physics_select", "report_entities", "report_touchlinks", "snd_digital_surround", "snd_restart", "soundlist", "soundscape_flush"
				, "wc_update_entity" };
	
/* Mani commands that will be disabled */
new String:block_mani[][] = { "timeleft", "nextmap", "ma_timeleft", "ma_nextmap", "listmaps", "ff" };

/* Cvars that clients are not permitted to have */
new String:forbidden_cvars[][] = { "sourcemod_version", "metamod_version", "mani_admin_plugin_version", "eventscripts_ver", "est_version", "bat_version", "beetlesmod_version" };

new cvar_pos[MAXPLAYERS];

new Handle:rcon_pw;
new bool:rcon_set=false;
new bool:logging=false;
new String:correct_rcon_pw[256];

new Handle:mintries;
new Handle:maxtries;

new Handle:cmdLogFile=INVALID_HANDLE;
new bool:bCmdLog=true;
new bool:bServerLog=true;

//Declare:
static String:ServerMap[255];

public OnPluginStart()
{

	//Print Server If Plugin Start:
	PrintToConsole(0, "|RolePlay| Unit antivirus and anticheat has Successfully Loaded (v%s)!", PLUGINVERSION);

	CreateConVar("sm_rconlock", PLUGINVERSION, "Plugin version", FCVAR_NOTIFY|FCVAR_REPLICATED|FCVAR_DONTRECORD);
	AddCommandListener(Cmd_EntCreate,"ent_create");
	AddCommandListener(Cmd_EntCreate,"give");
	AddCommandListener(Cmd_EntFire,"ent_fire");
	AddCommandListener(Cmd_Log,"log");
	
	RegConsoleCmd("changelevel",Cmd_ChangeLevel);

	// Grab the rcon password to prevent changes
	rcon_pw = FindConVar("rcon_password");
	HookConVarChange(rcon_pw,rcon_changed);

	// Flag any of the exploitable commands as cheats
	new Handle:curcmd;
	LogMessage("%i cheat commands",sizeof(cheat_flag));
	for (new i=0;i<sizeof(cheat_flag);i++)
	{
		if (GetCommandFlags(cheat_flag[i]) != INVALID_FCVAR_FLAGS)
		{
			if (GetCommandFlags(cheat_flag[i])&FCVAR_CHEAT)
			{
				continue;
			}
			SetCommandFlags(cheat_flag[i],GetCommandFlags(cheat_flag[i])|FCVAR_CHEAT);
		}
	}
	
	// Figure out if Mani is loaded
	if (FindConVar("mani_admin_plugin_version") != INVALID_HANDLE)
	{
		for (new i=0;i<sizeof(block_mani);i++)
		{
			curcmd = FindConVar(block_mani[i]);
			if (curcmd != INVALID_HANDLE)
			{
				SetConVarFlags(curcmd,GetConVarFlags(curcmd)|FCVAR_CHEAT);
			}
		}
	}
	
	if (FindConVar("eventscripts_ver") != INVALID_HANDLE)
	{
		LogMessage("Eventscripts detected, disabling server command logging");
		bServerLog = false;
	}
	
	// Remove convar bounds so the actual rcon crash can be prevented
	mintries = FindConVar("sv_rcon_minfailures");
	maxtries = FindConVar("sv_rcon_maxfailures");
	SetConVarBounds(mintries,ConVarBound_Upper,false);
	SetConVarBounds(maxtries,ConVarBound_Upper,false);
	
	
	AddCommandListener(HalfConnected);
	
	decl String:gamename[32];
	GetGameFolderName(gamename,sizeof(gamename));
	if (StrEqual(gamename,"left4dead",false) || StrEqual(gamename,"left4dead2",false))
	{	// Workaround for bug #4066
		HookEvent("game_start",game_start);
	}
	
	new String:temp[1024];
	BuildPath(Path_SM,temp,sizeof(temp),"configs/rcon_lock.cfg");
	if (FileExists(temp))
	{
		bCmdLog = false;
	}
}

//Map Start:
public OnMapStart()
{

	//Hook Entity Output:
	HookEntityOutput("game_end", "EndGame",EntityOutput);

	HookEntityOutput("point_servercommand","Command",EntityOutput);

	HookEntityOutput("point_clientcommand","Command",EntityOutput);

	//Initialize:
	GetCurrentMap(ServerMap, sizeof(ServerMap));

	if(StrEqual(ServerMap, "RP_City8_OutCast_MS"))
	{

		//Command:
		ServerCommand("sv_cheats 1");

		ServerCommand("ent_remove_all respawn");

		ServerCommand("ent_remove_all electichurt");

		ServerCommand("sv_cheats 0");

		//Print:
		PrintToServer("|RolePlay| Found Bad Entities (Removed).");
	}

	if(StrEqual(ServerMap, "rp_downtown_sp3a"))
	{

		//Command:
		ServerCommand("sv_cheats 1");

		ServerCommand("ent_remove_all yupthisisboring");

		ServerCommand("sv_cheats 0");

		//Print:
		PrintToServer("|RolePlay| Found Bad Entities (Removed).");
	}

	//Remove
	Perf_Erase();

}

public OnMapEnd()
{
	if (cmdLogFile != INVALID_HANDLE)
	{
		CloseHandle(cmdLogFile);
		cmdLogFile = INVALID_HANDLE;
	}
}

public Action:Cmd_Log(client, const String:command[], argc)
{
	if (client != 0) return Plugin_Continue;
	if (argc == 0) return Plugin_Continue;
	
	if (logging)
	{
		PrintToServer("Cannot stop logging right now.");
		return Plugin_Stop;
	}
	
	new String:arg1[32];
	GetCmdArg(1,arg1,sizeof(arg1));
	
	if (StrEqual(arg1,"on",false))
	{
		logging = true;
	}
	return Plugin_Continue;
}

/*
************************** CLIENT PLUGINS ********************************
*/
public OnClientPutInServer(client)
{
	cvar_pos[client] = 0;
	CreateTimer(5.0, CheckPlayer, client, TIMER_REPEAT);
	CreateTimer(5.0, StartTeleCheck, client, TIMER_REPEAT);
	OnClientSettingsChanged(client);
}

public Action:CheckPlayer(Handle:timer,any:value)
{
	if (!IsClientInGame(value) || IsFakeClient(value)) return Plugin_Stop;
	if (value >= sizeof(cvar_pos)) return Plugin_Stop;
	if (cvar_pos[value] >= sizeof(forbidden_cvars)) return Plugin_Stop;
	
	QueryClientConVar(value, forbidden_cvars[cvar_pos[value]], ConVarDone);
	cvar_pos[value]++;
	if (cvar_pos[value] >= sizeof(forbidden_cvars))
	{
		return Plugin_Stop;
	}
	return Plugin_Continue;
}

public ConVarDone(QueryCookie:cookie, client, ConVarQueryResult:result, const String:cvarName[], const String:cvarValue[], any:value)
{
	if (result != ConVarQuery_Okay && result != ConVarQuery_Protected) return;
	LogMessage("Removing client '%L' as %s=%s",client, cvarName, cvarValue);
	KickClient(client, "Please remove any plugins you are running");
}

/*
************************** RCON LOCK ********************************
*/

public game_start(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (!rcon_set) OnConfigsExecuted();
}
public OnConfigsExecuted()
{
	rcon_set = true;
	GetConVarString(rcon_pw,correct_rcon_pw,sizeof(correct_rcon_pw));
	if (GetConVarInt(mintries) == 5)
	{
		SetConVarInt(mintries,10000);
	}
	if (GetConVarInt(maxtries) == 10)
	{
		SetConVarInt(maxtries,10000);
	}
}

public rcon_changed(Handle:convar, const String:oldValue[], const String:newValue[])
{
	if (rcon_set && !StrEqual(newValue,correct_rcon_pw))
	{
		SetConVarString(rcon_pw,correct_rcon_pw);
	}
}

/*
************************** ENT_CREATE/ ENT_FIRE ********************************
*/
public Action:Cmd_EntCreate(client, const String:command[], argc)
{
	new String:entname[128];
	GetCmdArg(1,entname,sizeof(entname));

	for (new i=0;i<sizeof(forbidden_ents);i++)
	{
		if (StrEqual(entname,forbidden_ents[i],false))
		{
			if(!IsAdmin(client))
			{
				return Plugin_Handled;
			}
		}
	}
	return Plugin_Continue;
}

public Action:Cmd_EntFire(client, const String:command[], argc)
{
	new String:argstring[1024];
	GetCmdArgString(argstring,1024);

	for (new i=0;i<sizeof(forbidden_cmds);i++)
	{
		if (StrContains(argstring,forbidden_cmds[i],false) != -1)
		{
			if(!IsAdmin(client))
			{
				return Plugin_Handled;
			}
		}
	}
	return Plugin_Continue;
}

/*
********************************** CHANGELEVEL ***************************************
*/
public Action:Cmd_ChangeLevel(client, args)
{
	if (client != 0)
	{
		new String:argstring[1024];
		GetCmdArgString(argstring,1024);
		return Plugin_Stop;
	}
	return Plugin_Continue;
}
/*
********************************** UNNAMMED ***************************************
*/

public OnClientSettingsChanged(client)
{
	if (IsFakeClient(client)) return;
	new String:newname[128];
	GetClientName(client,newname,sizeof(newname));
	if (strlen(newname) == 0)
	{
		KickClient(client, "You have joined the server with an\ninvalid name, please rename and join.");
	}
}
/*
********************************** TELEPORT ***************************************
*/
	
public Action:StartTeleCheck(Handle:timer,any:value)
{
	if (!IsClientConnected(value) || !IsClientInGame(value)) return Plugin_Stop;
	QueryClientConVar(value, "sensitivity", TeleCheckDone);
	return Plugin_Continue;
}

public TeleCheckDone(QueryCookie:cookie, client, ConVarQueryResult:result, const String:cvarName[], const String:cvarValue[], any:value)
{
	if (result != ConVarQuery_Okay) return;
	new Float:fValue = StringToFloat(cvarValue);
	if (fValue < 1000.0) return;
	
	KickClient(client, "your sensitivity as been detected as spam, please lower to join.");
}


/*
********************************** EARLY CMD ***************************************
*/

public Action:HalfConnected(client, const String:command[], argc)
{
	new String:fulltext[2048];
	GetCmdArgString(fulltext,sizeof(fulltext));
	if (client == 0)
	{	
		if (bCmdLog && bServerLog)
			CmdLog(client,"%s %s",command,fulltext);

		return Plugin_Continue;
	}
	if (StrEqual(command,"menuclosed"))
	{	// the game sends this command very early for some reason
		// it's normal, so we don't want to log it
		return Plugin_Stop;
	}
	if (!IsClientConnected(client))
	{
		LogMessage("Got half-connected command from client %i (ip unknown): %s %s",client,command,fulltext);
		if (bCmdLog)
			CmdLog(-client,"(half connected) %s %s",command,fulltext);

		return Plugin_Stop;
	}
	if (!IsClientInGame(client))
	{
		decl String:ip[64];
		GetClientIP(client,ip,sizeof(ip));
		LogMessage("Got half-connected command from client %s: %s %s",ip,command,fulltext);
		if (bCmdLog)
			CmdLog(client,"(half connected) %s %s",command,fulltext);

		return Plugin_Stop;
	}
	if (bCmdLog)
		CmdLog(client,"%s %s",command,fulltext);

	return Plugin_Continue;	
}

public CmdLog(client, const String:format[], any:...)
{
	new String:log[2048], String:curtime[128];
	VFormat(log, sizeof(log), format, 3);
	FormatTime(curtime,sizeof(curtime),"%c");
	
	if (client >= 0)
	{
		Format(log,sizeof(log),"%s: %L executes: %s",curtime,client,log);
	}
	else
	{
		Format(log,sizeof(log),"%s: unknown<%i><unknown><> executes: %s",curtime,-client,log);
	}
	
	if (bCmdLog)
	{
		if (cmdLogFile == INVALID_HANDLE)
		{
			new String:temp[1024];
			FormatTime(temp,sizeof(temp),"%m.%d.%y");
			BuildPath(Path_SM,temp,sizeof(temp),"logs/cmd_%s.log",temp);
			cmdLogFile = OpenFile(temp,"a");
		}
	
	 
		WriteFileLine(cmdLogFile,"%s",log);
		FlushFile(cmdLogFile);
	}
}

public EntityOutput(const String:output[], Caller, Activator, Float:delay)
{

	new Count = 0;

	//Is Valid Entity:
	if(IsValidEntity(Caller))
	{

		if(IsValidEntity(Caller))
		{

			//Remove:
			RemoveEdict(Caller);

			//Initulize:
			Count++;
		}

		//Remove:
		RemoveEdict(Activator);
	}

	if(Count != 0)
	{

		//Print:
		PrintToServer("|RolePlay| Found Bad Entities (Removed)");
	}

	//Return:
	return true;
}

public Perf_Erase()
{

	//Declare:
	decl String:Class[128];

	new Count = 0;

	//Loop:
	for(new Ent = 0; Ent < 4096; Ent++)
	{

		//Is Entity:
		if(IsValidEdict(Ent))
		{

			//Get Class Name Of All Entitys:
			GetEdictClassname(Ent, Class, sizeof(Class));

			//Is Harmfull Entity:
			if((StrEqual(Class, "game_end", false) || StrEqual(Class, "point_clientcommand", false) || StrEqual(Class, "point_servercommand", false) || StrEqual(Class, "trigger_remove", false) || StrEqual(Class, "trigger_once", false)) || (StrEqual(Class, "func_tracktrain", false) && StrEqual(ServerMap, "rp_freemancity_kbm_public_v1")))
			{

				//Remove Entity:
				AcceptEntityInput(Ent, "kill");

				//Initulize:
				Count++;
			}
		}
	}

	if(Count != 0)
	{

		//Print:
		PrintToServer("|RolePlay| Found Bad Entities (Removed).");
	}

	if(Count == 0)
	{

		//Print:
		PrintToServer("|RolePlay| No Bad Entities Found.");
	}
}

public Action:OnLevelInit(const String:mapName[], String:mapEntities[2097152])
{

	//Is Harmfull Entity:
	if(StrContains(mapEntities, "game_end", false) == 0) ReplaceString(mapEntities, sizeof(mapEntities), "game_end", "blocked");
	if(StrContains(mapEntities, "point_clientcommand", false) == 0) ReplaceString(mapEntities, sizeof(mapEntities), "point_clientcommand", "blocked");
	if(StrContains(mapEntities, "point_servercommand", false) == 0) ReplaceString(mapEntities, sizeof(mapEntities), "point_Servercommand", "blocked");
	if(StrContains(mapEntities, "trigger_remove", false) == 0) ReplaceString(mapEntities, sizeof(mapEntities), "trigger_remove", "blocked");
	if(StrContains(mapEntities, "trigger_once", false) == 0) ReplaceString(mapEntities, sizeof(mapEntities), "trigger_once", "blocked");
	if(StrContains(mapEntities, "func_tracktrain", false) == 0) ReplaceString(mapEntities, sizeof(mapEntities), "func_tracktrain", "blocked");

	//Is Map:
	if(StrEqual(mapName, "rp_downtown_sp3a") || StrEqual(mapName, "rp_downtown_sp4a"))
	{

		//Replace:
		ReplaceString(mapEntities, sizeof(mapEntities), "vworldspawn", "worldspawn");

		//Declare:
		decl String:Class[128];

		//Loop:
		for(new Ent = 0; Ent < 4096; Ent++)
		{

			//Is Entity:
			if(IsValidEdict(Ent))
			{

				//Get Class Name Of All Entitys:
				GetEdictClassname(Ent, Class, sizeof(Class));

				//Is Harmfull Entity:
				if(StrEqual(Class, "vworldspawn", false))
				{

					//Ent:
					SetEntPropString(Ent, Prop_Data, "m_iClassname", "worldspawn");
				}
			}
		}

		//Return:
		return Plugin_Changed;
	}

	//Return:
	return Plugin_Continue;
}